package com.inca.npbusi.credit_adjust;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.NVPair;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.SendHelper;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.pubsrv.entryChoose.EntryChoosable;
import com.inca.pubsrv.work_flow.CDetailModel_WorkFlow;
import java.awt.event.ActionEvent;
import java.util.Iterator;
import java.util.Vector;

public class CreditAdjust_detail extends CDetailModel_WorkFlow {
   public CreditAdjust_detail(CFrame var1, CMdeModel var2) {
      super(var1, "信誉额度调整细单", var2);
   }

   public String getTablename() {
      return "bms_Credit_adjust_dtl_v";
   }

   public String getHovOtherWheres(int var1, String var2) {
      String var3;
      if (var2.equalsIgnoreCase("saleropcode")) {
         var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "entryid");
         var3 = this.getItemValue(var1, "customid");
         var3 = "employeeid in(select salerid from pub_custom_to_saler" + (var3.length() > 0 ? " where customid=" + var3 + " and entryid=" + var2 : " where entryid=" + var2) + ")";
         return var3 + " and get_entryid_by_deptid(deptid)=" + ((EntryChoosable)this.mdemodel.getMasterModel()).getEntry().getEntryid();
      } else if (var2.equalsIgnoreCase("customopcode")) {
         var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "entryid");
         var3 = this.getItemValue(var1, "salerid");
         return "customid in(select customid from pub_custom_to_saler" + (var3.length() > 0 ? " where salerid=" + var3 + " and entryid=" + var2 : " where entryid=" + var2) + ")";
      } else {
         return super.getHovOtherWheres(var1, var2);
      }
   }

   protected String getEditablecolumns(int var1) {
      if (this.on_beforemodify(var1) < 0) {
         return "";
      } else {
         String var2 = ((CMdeModelAp)this.mdemodel).getApvalue("调整项目");
         String var3 = "";
         if (!var2.equals("只调整额度") && !var2.equals("只调整天数")) {
            var3 = ",adjustItem";
         }

         var2 = this.getItemValue(var1, "adjustItem");
         if (var2.equals("1")) {
            var3 = var3 + ",credit";
         } else if (var2.equals("2")) {
            var3 = var3 + ",days";
         } else {
            var3 = var3 + ",credit,days";
         }

         if ((var2 = this.getItemValue(var1, "credit_level")).equals("")) {
            return "credit_level,begindate,enddate,dtlmemo" + var3;
         } else if (!var2.equals("1") && !var2.equals("3")) {
            if (!var2.equals("2") && !var2.equals("4")) {
               return !var2.equals("5") && !var2.equals("6") ? super.getEditablecolumns(var1) : "credit_level,begindate,enddate,dtlmemo,customopcode" + var3;
            } else {
               return "credit_level,begindate,enddate,dtlmemo,saleropcode" + var3;
            }
         } else {
            return "credit_level,begindate,enddate,dtlmemo,saleropcode,customopcode" + var3;
         }
      }
   }

   protected void on_itemvaluechange(int var1, String var2, String var3) {
      if (var2.equalsIgnoreCase("credit_level")) {
         System.err.println("value" + var3);
         this.setItemValue(var1, "saleropcode", "");
         this.setItemValue(var1, "salername", "");
         this.setItemValue(var1, "salerid", "");
         this.setItemValue(var1, "customopcode", "");
         this.setItemValue(var1, "customname", "");
         this.setItemValue(var1, "customid", "");
         this.a(var1, false);
      } else if (var2.equalsIgnoreCase("begindate")) {
         if (!var3.equals("")) {
            this.setItemValue(var1, var2, var3.substring(0, 10) + " 00:00:00");
         }
      } else if (var2.equalsIgnoreCase("enddate")) {
         if (!var3.equals("")) {
            this.setItemValue(var1, var2, var3.substring(0, 10) + " 23:59:59");
         }
      } else if (!var2.equalsIgnoreCase("salerid") && !var2.equalsIgnoreCase("customid")) {
         if (var2.equalsIgnoreCase("adjustitem")) {
            if (var3.equals("1")) {
               this.setItemValue(var1, "days", "");
            } else if (var3.equals("2")) {
               this.setItemValue(var1, "credit", "");
            } else {
               this.setItemValue(var1, "credit", "");
               this.setItemValue(var1, "days", "");
            }
         }
      } else {
         this.a(var1, false);
      }

      super.on_itemvaluechange(var1, var2, var3);
   }

   protected int on_checkrow(int var1, DBTableModel var2) {
      int var3 = this.mdemodel.getMasterModel().getRow();
      String var6;
      if (!(var6 = this.mdemodel.getMasterModel().getItemValue(var3, "adjusttype")).equals("2") || !this.getItemValue(var1, "begindate").equals("") && !this.getItemValue(var1, "begindate").startsWith("00")) {
         if (var6.equals("2") && (this.getItemValue(var1, "enddate").equals("") || this.getItemValue(var1, "enddate").startsWith("00"))) {
            this.infoMessage("细单提示", "调整临时额度必须要有截止时间");
            this.setFocus("enddate");
            return -1;
         } else {
            var6 = this.getItemValue(var1, "credit_level");
            String var4 = this.getItemValue(var1, "salerid");
            String var5 = this.getItemValue(var1, "customid");
            if (var6.equals("")) {
               this.infoMessage("细单提示", "维度必须要填写！");
               this.setFocus("credit_level");
               return -1;
            } else if ((var6.equals("1") || var6.equals("3")) && (var4.equals("") || var5.equals(""))) {
               this.infoMessage("细单提示", "业务员和客户必须要填写！");
               this.setFocus("customid");
               return -1;
            } else if ((var6.equals("2") || var6.equals("4")) && var4.equals("")) {
               this.infoMessage("细单提示", "业务员必须要填写！");
               this.setFocus("salerid");
               return -1;
            } else if ((var6.equals("5") || var6.equals("6")) && var5.equals("")) {
               this.infoMessage("细单提示", "客户必须要填写！");
               this.setFocus("customid");
               return -1;
            } else {
               var6 = this.getItemValue(var1, "adjustitem");
               if ("1".equals(var6)) {
                  if (this.a(var1) == -1) {
                     return -1;
                  }
               } else if ("2".equals(var6)) {
                  if (this.b(var1) == -1) {
                     return -1;
                  }
               } else if ("3".equals(var6)) {
                  if (this.b(var1) == -1) {
                     return -1;
                  }

                  if (this.a(var1) == -1) {
                     return -1;
                  }
               }

               return super.on_checkrow(var1, var2);
            }
         }
      } else {
         this.infoMessage("细单提示", "调整临时额度必须要有开始时间");
         this.setFocus("begindate");
         return -1;
      }
   }

   private int a(int var1) {
      String var2 = this.getItemValue(var1, "credit");
      if ("".equals(var2)) {
         this.infoMessage("细单提示", "信誉额度不能为空！");
         this.setFocus("credit");
         return -1;
      } else if (DecimalHelper.comparaDecimal(var2, "0") <= 0) {
         this.infoMessage("细单提示", "信誉额度不能是负数或0！");
         this.setFocus("credit");
         return -1;
      } else {
         return 0;
      }
   }

   private int b(int var1) {
      String var2 = this.getItemValue(var1, "days");
      if ("".equals(var2)) {
         this.infoMessage("细单提示", "信誉天数不能为空！");
         this.setFocus("days");
         return -1;
      } else if (DecimalHelper.comparaDecimal(var2, "0") <= 0) {
         this.infoMessage("细单提示", "信誉天数不能是负数或0！");
         this.setFocus("days");
         return -1;
      } else {
         return 0;
      }
   }

   protected int on_new(int var1) {
      int var2 = this.mdemodel.getMasterModel().getRow();
      String var3 = this.mdemodel.getMasterModel().getItemValue(var2, "begindate");
      this.setItemValue(var1, "begindate", var3);
      this.on_itemvaluechange(var1, "begindate", var3);
      var3 = this.mdemodel.getMasterModel().getItemValue(var2, "enddate");
      this.setItemValue(var1, "enddate", var3);
      this.on_itemvaluechange(var1, "enddate", var3);
      this.setItemValue(var1, "usestatus", "1");
      String var4;
      if ((var4 = ((CMdeModelAp)this.mdemodel).getApvalue("调整项目")).equals("只调整额度")) {
         this.setItemValue(var1, "adjustitem", "1");
      } else if (var4.equals("只调整天数")) {
         this.setItemValue(var1, "adjustitem", "2");
      } else {
         this.setItemValue(var1, "adjustitem", "3");
      }

      return super.on_new(var1);
   }

   public void actionPerformed(ActionEvent var1) {
      if ("查询当前数据".equals(var1.getActionCommand())) {
         if (!this.d()) {
            this.infoMessage("细单提示", "不是你录入的单据!");
            return;
         }

         this.a(this.getRow(), true);
      } else if ("执行全部".equals(var1.getActionCommand())) {
         CreditAdjust_detail var2 = this;
         if (!((CMdeModelAp)this.mdemodel).getApvalue("执行全部").equals("1")) {
            this.infoMessage("细单提示", "没有执行全部权限");
         } else {
            ParamCommand var3;
            (var3 = new ParamCommand()).addParam("action", "执行全部");
            ClientRequest var4;
            (var4 = new ClientRequest("sa.CreditAdjust.后台服务")).addCommand(var3);

            try {
               StringCommand var6;
               if (!(var6 = (StringCommand)SendHelper.sendRequest(var4).commandAt(0)).getString().startsWith("+")) {
                  throw new Exception(var6.getString());
               }

               var2.infoMessage("细单提示", "执行操作完成");
            } catch (Exception var5) {
               this.infoMessage("执行操作失败", var5.getMessage());
            }
         }
      } else if ("作废".equals(var1.getActionCommand())) {
         this.a();
      } else if ("执行".equals(var1.getActionCommand())) {
         this.b();
      }

      super.actionPerformed(var1);
   }

   protected int on_beforedel(int var1) {
      if (super.on_beforedel(var1) < 0) {
         return -1;
      } else if (this.getdbStatus(var1) != 1 && !this.getItemValue(var1, "usestatus").equals("1")) {
         return -1;
      } else {
         return !this.d() ? -1 : 0;
      }
   }

   protected int on_beforeNew() {
      return !this.d() ? -1 : super.on_beforeNew();
   }

   protected int on_beforemodify(int var1) {
      if (!this.d()) {
         return -1;
      } else if (super.on_beforemodify(var1) < 0) {
         return -1;
      } else if (this.getdbStatus(var1) != 1 && !this.getItemValue(var1, "usestatus").equals("1")) {
         return -1;
      } else {
         String var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "adjusttype");
         if ("1".equals(var2)) {
            this.getDBColumnDisplayInfo("begindate").setReadonly(true);
            this.getDBColumnDisplayInfo("enddate").setReadonly(true);
         } else {
            this.getDBColumnDisplayInfo("begindate").setReadonly(false);
            this.getDBColumnDisplayInfo("enddate").setReadonly(false);
         }

         return 0;
      }
   }

   private void a() {
      int[] var1;
      if ((var1 = this.table.getSelectedRows()).length == 0) {
         this.infoMessage("细单提示", "请多选细单");
      } else if (!this.d()) {
         this.infoMessage("细单提示", "不是你录入的单据，不能作废");
      } else {
         ParamCommand var2;
         (var2 = new ParamCommand()).addParam("action", "作废");

         for(int var3 = 0; var3 < var1.length; ++var3) {
            if (!this.getItemValue(var1[var3], "usestatus").equals("1")) {
               this.infoMessage("细单提示", "第" + (var1[var3] + 1) + "行细单不是临时状态");
               return;
            }

            if (this.getdbStatus(var1[var3]) != 0) {
               this.infoMessage("细单提示", "第" + (var1[var3] + 1) + "行细单没有保存");
               return;
            }

            var2.addParam("i" + var3, this.getItemValue(var1[var3], "credit_adjust_dtl_id"));
         }

         ClientRequest var7;
         (var7 = new ClientRequest("sa.CreditAdjust.后台服务")).addCommand(var2);

         try {
            StringCommand var5;
            if (!(var5 = (StringCommand)SendHelper.sendRequest(var7).commandAt(0)).getString().startsWith("+")) {
               throw new Exception(var5.getString());
            } else {
               for(int var6 = 0; var6 < var1.length; ++var6) {
                  this.setItemValue(var1[var6], "usestatus", "0");
                  this.setdbStatus(var1[var6], 0);
               }

               this.infoMessage("细单提示", "作废操作完成");
            }
         } catch (Exception var4) {
            this.infoMessage("作废操作失败", var4.getMessage());
         }
      }
   }

   private void b() {
      if (!((CMdeModelAp)this.mdemodel).getApvalue("执行").equals("1")) {
         this.infoMessage("细单提示", "没有执行权限");
      } else {
         int[] var1 = this.table.getSelectedRows();

         int var2;
         for(var2 = 0; var2 < var1.length; ++var2) {
            if (this.getdbStatus(var1[var2]) != 0) {
               this.infoMessage("细单提示", "第" + (var1[var2] + 1) + "行细单没有保存");
               return;
            }
         }

         ParamCommand var12;
         (var12 = new ParamCommand()).addParam("action", "执行");
         DataCommand var9 = this.c();
         ClientRequest var3;
         (var3 = new ClientRequest("sa.CreditAdjust.后台服务")).addCommand(var12);
         var3.addCommand(var9);

         try {
            ServerResponse var10;
            StringCommand var13;
            if (!(var13 = (StringCommand)(var10 = SendHelper.sendRequest(var3)).commandAt(0)).getString().startsWith("+")) {
               throw new Exception(var13.getString());
            } else {
               DBTableModel var11 = ((DataCommand)var10.commandAt(1)).getDbmodel();

               for(var2 = 0; var2 < var11.getRowCount(); ++var2) {
                  String var14 = var11.getItemValue(var2, "credit_adjust_dtl_id");
                  String var4 = var11.getItemValue(var2, "msg");
                  String var5 = var11.getItemValue(var2, "resultStatus");

                  for(int var6 = 0; var6 < this.getRowCount(); ++var6) {
                     String var7 = this.getItemValue(var6, "credit_adjust_dtl_id");
                     if (var14.equals(var7)) {
                        if (var5.equals("1")) {
                           this.setItemValue(var6, "useStatus", "4");
                        }

                        this.setdbStatus(var6, 0);
                        this.getDBtableModel().getRecordThunk(var6).setSaveresult(var5.equals("1") ? 0 : 1, var4);
                     }
                  }
               }

            }
         } catch (Exception var8) {
            this.infoMessage("执行操作失败", var8.getMessage());
         }
      }
   }

   private DataCommand c() {
      DataCommand var1 = new DataCommand();
      Vector var2 = new Vector();
      DBColumnDisplayInfo var3 = new DBColumnDisplayInfo("credit_adjust_dtl_id", "number");
      var2.add(var3);
      var3 = new DBColumnDisplayInfo("resultStatus", "varchar");
      var2.add(var3);
      var3 = new DBColumnDisplayInfo("msg", "varchar");
      var2.add(var3);
      DBTableModel var5 = new DBTableModel(var2);
      int[] var6 = this.getTable().getSelectedRows();

      for(int var4 = 0; var4 < var6.length; ++var4) {
         var5.appendRow();
         var5.setItemValue(var4, "credit_adjust_dtl_id", this.getItemValue(var6[var4], "credit_adjust_dtl_id"));
      }

      var1.setDbmodel(var5);
      return var1;
   }

   private boolean d() {
      int var1;
      return (var1 = this.mdemodel.getMasterModel().getRow()) < 0 ? false : this.mdemodel.getMasterModel().getItemValue(var1, "inputmanid").equals(ClientUserManager.getCurrentUser().getUserid());
   }

   private void a(int var1, boolean var2) {
      if (var1 >= 0) {
         int var3 = this.getdbStatus(var1);
         String var4 = this.getItemValue(var1, "credit_level");
         String var5 = this.getItemValue(var1, "salerid");
         String var6 = this.getItemValue(var1, "customid");
         if (var4.equals("")) {
            if (var2) {
               this.infoMessage("细单提示", "信誉额度级别必须要填写！");
            }

            this.setItemValue(var1, "Original_credit", "");
            this.setItemValue(var1, "Original_days", "");
         } else if (!var4.equals("1") && !var4.equals("3") || !var5.equals("") && !var6.equals("")) {
            if ((var4.equals("2") || var4.equals("4")) && var5.equals("")) {
               if (var2) {
                  this.infoMessage("细单提示", "业务员必须要填写！");
               }

               this.setItemValue(var1, "Original_credit", "");
               this.setItemValue(var1, "Original_days", "");
            } else if (var4.equals("5") && var6.equals("")) {
               if (var2) {
                  this.infoMessage("细单提示", "客户必须要填写！");
               }

               this.setItemValue(var1, "Original_credit", "");
               this.setItemValue(var1, "Original_days", "");
            } else {
               int var9 = this.mdemodel.getMasterModel().getRow();
               String var10 = this.mdemodel.getMasterModel().getItemValue(var9, "entryid");
               ParamCommand var7;
               (var7 = new ParamCommand()).addParam("action", "查询当前数据");
               var7.addParam("level", var4);
               var7.addParam("salerid", var5);
               var7.addParam("customid", var6);
               var7.addParam("entryid", var10);
               var7.addParam("subflag", "0");
               ClientRequest var11;
               (var11 = new ClientRequest("sa.CreditAdjust.后台服务")).addCommand(var7);

               try {
                  ServerResponse var12;
                  StringCommand var14;
                  if (!(var14 = (StringCommand)(var12 = SendHelper.sendRequest(var11)).commandAt(0)).getString().startsWith("+")) {
                     throw new Exception(var14.getString());
                  } else {
                     DBTableModel var13;
                     if ((var13 = ((DataCommand)var12.commandAt(1)).getDbmodel()).getRowCount() == 0) {
                        this.setItemValue(var1, "Original_credit", "");
                        this.setItemValue(var1, "Original_days", "");
                     } else {
                        this.setItemValue(var1, "Original_credit", var13.getItemValue(0, "c"));
                        this.setItemValue(var1, "Original_days", var13.getItemValue(0, "d"));
                     }

                     this.setdbStatus(var1, var3);
                     this.tableChanged();
                  }
               } catch (Exception var8) {
                  this.infoMessage("细单提示", "取原信誉额度出错:\n" + var8.getMessage());
                  this.setItemValue(var1, "Original_credit", "");
                  this.setItemValue(var1, "Original_days", "");
               }
            }
         } else {
            if (var2) {
               this.infoMessage("细单提示", "业务员和客户必须要填写！");
            }

            this.setItemValue(var1, "Original_credit", "");
            this.setItemValue(var1, "Original_days", "");
         }
      }
   }

   public ParamCommand getCommitParam() {
      ParamCommand var1;
      (var1 = new ParamCommand()).addParam("tablename", "bms_Credit_adjust_dtl");
      var1.addParam("pkcolname", "Credit_adjust_dtl_id");
      var1.addParam("wheres", "usestatus=1");
      var1.addParam("updatecol", "usestatus=2,wfusestatus=1");
      return var1;
   }

   public void on_Commit(ParamCommand var1) {
      Iterator var2 = var1.getNvpairs().iterator();

      while(var2.hasNext()) {
         int var3 = Integer.valueOf(((NVPair)var2.next()).getName());
         this.setItemValue(var3, "wfusestatus", "1");
         this.setItemValue(var3, "usestatus", "2");
         this.setdbStatus(var3, 0);
      }

   }

   public boolean on_beforeCommit(int var1) {
      if (!this.getItemValue(var1, "usestatus").equals("1")) {
         this.infoMessage("细单提示", "第" + (var1 + 1) + "行不是临时状态");
         return false;
      } else {
         return true;
      }
   }
}
